diff --git a/res/res_pjsip/pjsip_options.c b/res/res_pjsip/pjsip_options.c
index d4ea911c95..9bec5de7b1 100644
--- a/res/res_pjsip/pjsip_options.c
+++ b/res/res_pjsip/pjsip_options.c
@@ -917,38 +1850,34 @@ static char *cli_qualify(struct ast_cli_entry *e, int cmd, struct ast_cli_args *
 
 	endpoint_name = a->argv[2];
 
-	if (!(endpoint = ast_sorcery_retrieve_by_id(
-		      ast_sip_get_sorcery(), "endpoint", endpoint_name))) {
+	endpoint = ast_sorcery_retrieve_by_id(ast_sip_get_sorcery(), "endpoint",
+		endpoint_name);
+	if (!endpoint) {
 		ast_cli(a->fd, "Unable to retrieve endpoint %s\n", endpoint_name);
 		return CLI_FAILURE;
 	}
 
-	qual_data = qualify_data_alloc(endpoint, a->fd);
-	if (!qual_data) {
+	if (ast_strlen_zero(endpoint->aors)) {
+		ast_cli(a->fd, "No AORs configured for endpoint '%s'\n", endpoint_name);
 		return CLI_FAILURE;
 	}
 
-	if (ast_sip_push_task(NULL, cli_qualify_contacts, qual_data)) {
-		qualify_data_destroy(qual_data);
-		return CLI_FAILURE;
-	}
+	aors = ast_strdupa(endpoint->aors);
+	while ((aor_name = ast_strip(strsep(&aors, ",")))) {
+		struct sip_options_aor *aor_options;
 
-	return CLI_SUCCESS;
-}
+		aor_options = ao2_find(sip_options_aors, aor_name, OBJ_SEARCH_KEY);
+		if (!aor_options) {
+			continue;
+		}
 
-/*!
- * \internal
- * \brief Send qualify request to the given contact.
- */
-static int ami_contact_cb(void *obj, void *arg, int flags)
-{
-	struct ast_sip_contact *contact = obj;
+		ast_cli(a->fd, "Qualifying AOR '%s' on endpoint '%s'\n", aor_name, endpoint_name);
 
-	ao2_ref(contact, +1);
-	if (ast_sip_push_task(NULL, qualify_contact_task, contact)) {
-		ao2_ref(contact, -1);
+		ast_sip_push_task_synchronous(aor_options->serializer, sip_options_qualify_aor_task, aor_options);
+		/* The synchronous task will release the reference */
 	}
-	return 0;
+
+	return CLI_SUCCESS;
 }
 
 static int ami_sip_qualify(struct mansession *s, const struct message *m)
@@ -978,21 +1907,15 @@ static int ami_sip_qualify(struct mansession *s, const struct message *m)
 
 	aors = ast_strdupa(endpoint->aors);
 	while ((aor_name = ast_strip(strsep(&aors, ",")))) {
-		struct ast_sip_aor *aor;
-		struct ao2_container *contacts;
+		struct sip_options_aor *aor_options;
 
-		aor = ast_sip_location_retrieve_aor(aor_name);
-		if (!aor) {
+		aor_options = ao2_find(sip_options_aors, aor_name, OBJ_SEARCH_KEY);
+		if (!aor_options) {
 			continue;
 		}
 
-		contacts = ast_sip_location_retrieve_aor_contacts(aor);
-		if (contacts) {
-			ao2_callback(contacts, OBJ_NODATA, ami_contact_cb, NULL);
-			ao2_ref(contacts, -1);
-		}
-
-		ao2_ref(aor, -1);
+		ast_sip_push_task_synchronous(aor_options->serializer, sip_options_qualify_aor_task, aor_options);
+		/* The synchronous task will release the reference */
 	}
 
 	astman_send_ack(s, m, "Endpoint found, will qualify");
@@ -1003,230 +1926,6 @@ static struct ast_cli_entry cli_options[] = {
 	AST_CLI_DEFINE(cli_qualify, "Send an OPTIONS request to a PJSIP endpoint")
 };
 
-static int sched_qualifies_hash_fn(const void *obj, int flags)
-{
-	const struct sched_data *object;
-	const struct ast_sip_contact *key;
-
-	switch (flags & OBJ_SEARCH_MASK) {
-	case OBJ_SEARCH_KEY:
-		key = obj;
-		break;
-	case OBJ_SEARCH_OBJECT:
-		object = obj;
-		key = object->contact;
-		break;
-	default:
-		/* Hash can only work on something with a full key. */
-		ast_assert(0);
-		return 0;
-	}
-	return ast_str_hash(ast_sorcery_object_get_id(key));
-}
-
-static int sched_qualifies_cmp_fn(void *obj, void *arg, int flags)
-{
-	const struct sched_data *object_left = obj;
-	const struct sched_data *object_right = arg;
-	struct ast_sip_contact *right_key = arg;
-	int cmp;
-
-	switch (flags & OBJ_SEARCH_MASK) {
-	case OBJ_SEARCH_OBJECT:
-		right_key = object_right->contact;
-		/* Fall through */
-	case OBJ_SEARCH_KEY:
-		cmp = strcmp(ast_sorcery_object_get_id(object_left->contact),
-			ast_sorcery_object_get_id(right_key));
-		break;
-	case OBJ_SEARCH_PARTIAL_KEY:
-		/* Not supported by container. */
-		ast_assert(0);
-		return 0;
-	default:
-		/*
-		 * What arg points to is specific to this traversal callback
-		 * and has no special meaning to astobj2.
-		 */
-		cmp = 0;
-		break;
-	}
-	if (cmp) {
-		return 0;
-	}
-	/*
-	 * At this point the traversal callback is identical to a sorted
-	 * container.
-	 */
-	return CMP_MATCH;
-}
-
-static int rtt_start_handler(const struct aco_option *opt,
-	struct ast_variable *var, void *obj)
-{
-	struct ast_sip_contact_status *status = obj;
-	long int sec, usec;
-
-	if (sscanf(var->value, "%ld.%06ld", &sec, &usec) != 2) {
-		return -1;
-	}
-
-	status->rtt_start = ast_tv(sec, usec);
-
-	return 0;
-}
-
-static int rtt_start_to_str(const void *obj, const intptr_t *args, char **buf)
-{
-	const struct ast_sip_contact_status *status = obj;
-
-	if (ast_asprintf(buf, "%ld.%06ld", (long)status->rtt_start.tv_sec, (long)status->rtt_start.tv_usec) == -1) {
-		return -1;
-	}
-
-	return 0;
-}
-
-static char status_value_unknown[2];
-static char status_value_created[2];
-
-int ast_sip_initialize_sorcery_qualify(void)
-{
-	struct ast_sorcery *sorcery = ast_sip_get_sorcery();
-
-	/* initialize sorcery ast_sip_contact_status resource */
-	ast_sorcery_apply_default(sorcery, CONTACT_STATUS, "memory", NULL);
-	ast_sorcery_object_set_congestion_levels(sorcery, CONTACT_STATUS, -1,
-		3 * AST_TASKPROCESSOR_HIGH_WATER_LEVEL);
-
-	if (ast_sorcery_internal_object_register(sorcery, CONTACT_STATUS,
-					contact_status_alloc, NULL, NULL)) {
-		ast_log(LOG_ERROR, "Unable to register ast_sip_contact_status in sorcery\n");
-		return -1;
-	}
-
-	snprintf(status_value_unknown, sizeof(status_value_unknown), "%u", UNKNOWN);
-	ast_sorcery_object_field_register_nodoc(sorcery, CONTACT_STATUS, "last_status",
-		status_value_unknown, OPT_UINT_T, 0, FLDSET(struct ast_sip_contact_status, last_status));
-	snprintf(status_value_created, sizeof(status_value_created), "%u", CREATED);
-	ast_sorcery_object_field_register_nodoc(sorcery, CONTACT_STATUS, "status",
-		status_value_created, OPT_UINT_T, 0, FLDSET(struct ast_sip_contact_status, status));
-	ast_sorcery_object_field_register_custom_nodoc(sorcery, CONTACT_STATUS, "rtt_start",
-		"0.0", rtt_start_handler, rtt_start_to_str, NULL, 0, 0);
-	ast_sorcery_object_field_register_nodoc(sorcery, CONTACT_STATUS, "rtt",
-		"0", OPT_UINT_T, 0, FLDSET(struct ast_sip_contact_status, rtt));
-
-	return 0;
-}
-
-static void qualify_and_schedule_contact(struct ast_sip_contact *contact)
-{
-	int initial_interval;
-	int max_time = ast_sip_get_max_initial_qualify_time();
-
-	/* Delay initial qualification by a random fraction of the specified interval */
-	if (max_time && max_time < contact->qualify_frequency) {
-		initial_interval = max_time;
-	} else {
-		initial_interval = contact->qualify_frequency;
-	}
-
-	initial_interval = (int)((initial_interval * 1000) * ast_random_double());
-
-	unschedule_qualify(contact);
-	if (contact->qualify_frequency) {
-		schedule_qualify(contact, initial_interval);
-	} else {
-		update_contact_status(contact, UNKNOWN, 0);
-	}
-}
-
-static int qualify_and_schedule_cb_with_aor(void *obj, void *arg, int flags)
-{
-	struct ast_sip_contact *contact = obj;
-	struct ast_sip_aor *aor = arg;
-
-	contact->qualify_frequency = aor->qualify_frequency;
-	contact->qualify_timeout = aor->qualify_timeout;
-	contact->authenticate_qualify = aor->authenticate_qualify;
-
-	qualify_and_schedule_contact(contact);
-
-	return 0;
-}
-
-static int qualify_and_schedule_cb_without_aor(void *obj, void *arg, int flags)
-{
-	qualify_and_schedule_contact((struct ast_sip_contact *) obj);
-
-	return 0;
-}
-
-/*!
- * \internal
- * \brief Qualify and schedule an aor's contacts
- *
- * \details For the given aor check if it has permanent contacts,
- *         qualify all contacts and schedule for checks if configured.
- */
-static int qualify_and_schedule_all_cb(void *obj, void *arg, int flags)
-{
-	struct ast_sip_aor *aor = obj;
-	struct ao2_container *contacts;
-
-	if (aor->permanent_contacts) {
-		contacts = ast_sip_location_retrieve_aor_contacts(aor);
-		if (contacts) {
-			ao2_callback(contacts, OBJ_NODATA, qualify_and_schedule_cb_with_aor, aor);
-			ao2_ref(contacts, -1);
-		}
-	}
-
-	return 0;
-}
-
-/*!
- * \internal
- * \brief Unschedule all existing contacts
- */
-static int unschedule_all_cb(void *obj, void *arg, int flags)
-{
-	struct sched_data *data = obj;
-
-	AST_SCHED_DEL_UNREF(sched, data->id, ao2_ref(data, -1));
-
-	return CMP_MATCH;
-}
-
-static void qualify_and_schedule_all(void)
-{
-	struct ast_variable *var = ast_variable_new("qualify_frequency >", "0", "");
-	struct ao2_container *aors;
-	struct ao2_container *contacts;
-
-	if (!var) {
-		return;
-	}
-	aors = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(),
-		"aor", AST_RETRIEVE_FLAG_MULTIPLE, var);
-
-	ao2_callback(sched_qualifies, OBJ_NODATA | OBJ_MULTIPLE | OBJ_UNLINK, unschedule_all_cb, NULL);
-
-	if (aors) {
-		ao2_callback(aors, OBJ_NODATA, qualify_and_schedule_all_cb, NULL);
-		ao2_ref(aors, -1);
-	}
-
-	contacts = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(),
-		"contact", AST_RETRIEVE_FLAG_MULTIPLE, var);
-	if (contacts) {
-		ao2_callback(contacts, OBJ_NODATA, qualify_and_schedule_cb_without_aor, NULL);
-		ao2_ref(contacts, -1);
-	}
-
-	ast_variables_destroy(var);
-
-}
 
 int ast_sip_format_contact_ami(void *obj, void *arg, int flags)
 {
@@ -1242,9 +1941,7 @@ int ast_sip_format_contact_ami(void *obj, void *arg, int flags)
 		return -1;
 	}
 
-	status = ast_sorcery_retrieve_by_id(
-		ast_sip_get_sorcery(), CONTACT_STATUS,
-		ast_sorcery_object_get_id(contact));
+	status = ast_sip_get_contact_status(contact);
 
 	ast_str_append(&buf, 0, "AOR: %s\r\n", wrapper->aor_id);
 	ast_str_append(&buf, 0, "URI: %s\r\n", contact->uri);
@@ -1278,7 +1975,7 @@ int ast_sip_format_contact_ami(void *obj, void *arg, int flags)
 
 	astman_append(ami->s, "%s\r\n", ast_str_buffer(buf));
 	ami->count++;
-	
+
 	ast_free(buf);
 	ao2_cleanup(status);
 	return 0;
@@ -1302,218 +1999,107 @@ static struct ast_sip_endpoint_formatter contact_status_formatter = {
 	.format_ami = format_ami_contact_status
 };
 
-static void aor_observer_modified(const void *obj)
+void ast_res_pjsip_cleanup_options_handling(void)
 {
-	struct ast_sip_aor *aor = (void *)obj;
-	struct ao2_container *contacts;
+	ast_cli_unregister_multiple(cli_options, ARRAY_LEN(cli_options));
+	ast_manager_unregister("PJSIPQualify");
+	internal_sip_unregister_endpoint_formatter(&contact_status_formatter);
 
-	contacts = ast_sip_location_retrieve_aor_contacts(aor);
-	if (contacts) {
-		ao2_callback(contacts, OBJ_NODATA, qualify_and_schedule_cb_with_aor, aor);
-		ao2_ref(contacts, -1);
+	if (sched) {
+		ast_sched_context_destroy(sched);
 	}
-}
-
-static int unschedule_contact_cb(void *obj, void *arg, int flags)
-{
-	unschedule_qualify(obj);
-
-	return CMP_MATCH;
-}
-
-static void aor_observer_deleted(const void *obj)
-{
-	const struct ast_sip_aor *aor = obj;
-	struct ao2_container *contacts;
 
-	contacts = ast_sip_location_retrieve_aor_contacts(aor);
-	if (contacts) {
-		ao2_callback(contacts, OBJ_NODATA | OBJ_MULTIPLE, unschedule_contact_cb, NULL);
-		ao2_ref(contacts, -1);
-	}
+	ast_sorcery_observer_remove(ast_sip_get_sorcery(), "contact", &contact_observer_callbacks);
+	ast_sorcery_observer_remove(ast_sip_get_sorcery(), "aor", &aor_observer_callbacks);
+	ast_sorcery_observer_remove(ast_sip_get_sorcery(), "endpoint", &endpoint_observer_callbacks);
+	ast_taskprocessor_unreference(management_serializer);
+	ao2_cleanup(sip_options_aors);
+	ao2_cleanup(sip_options_contact_statuses);
+	ao2_cleanup(sip_options_endpoint_state_compositors);
+	pjsip_endpt_unregister_module(ast_sip_get_pjsip_endpoint(), &options_module);
 }
 
-static const struct ast_sorcery_observer observer_callbacks_options = {
-	.created = aor_observer_modified,
-	.updated = aor_observer_modified,
-	.deleted = aor_observer_deleted
-};
-
-static int aor_update_endpoint_state(void *obj, void *arg, int flags)
+int ast_res_pjsip_init_options_handling(int reload)
 {
-	struct ast_sip_endpoint *endpoint = obj;
-	const char *endpoint_name = ast_sorcery_object_get_id(endpoint);
-	char *aor = arg;
-	char *endpoint_aor;
-	char *endpoint_aors;
+	static const pj_str_t STR_OPTIONS = { "OPTIONS", 7 };
+	char tps_name[AST_TASKPROCESSOR_MAX_NAME + 1];
 
-	if (ast_strlen_zero(aor) || ast_strlen_zero(endpoint->aors)) {
+	if (reload) {
+		sip_options_synchronize(1);
 		return 0;
 	}
 
-	endpoint_aors = ast_strdupa(endpoint->aors);
-	while ((endpoint_aor = ast_strip(strsep(&endpoint_aors, ",")))) {
-		if (!strcmp(aor, endpoint_aor)) {
-			if (ast_sip_persistent_endpoint_update_state(endpoint_name, AST_ENDPOINT_ONLINE) == -1) {
-				ast_log(LOG_WARNING, "Unable to find persistent endpoint '%s' for aor '%s'\n",
-					endpoint_name, aor);
-			}
-		}
+	if (pjsip_endpt_register_module(ast_sip_get_pjsip_endpoint(), &options_module) != PJ_SUCCESS) {
+		return -1;
 	}
 
-	return 0;
-}
-
-static int on_aor_update_endpoint_state(void *obj, void *arg, int flags)
-{
-	struct ast_sip_aor *aor = obj;
-	struct ao2_container *endpoints;
-	RAII_VAR(struct ast_variable *, var, NULL, ast_variables_destroy);
-	const char *aor_name = ast_sorcery_object_get_id(aor);
-	char *aor_like;
-
-	if (ast_strlen_zero(aor_name)) {
+	if (pjsip_endpt_add_capability(ast_sip_get_pjsip_endpoint(), NULL, PJSIP_H_ALLOW,
+		NULL, 1, &STR_OPTIONS) != PJ_SUCCESS) {
+		ast_res_pjsip_cleanup_options_handling();
 		return -1;
 	}
 
-	if (aor->permanent_contacts && ((int)(aor->qualify_frequency * 1000)) <= 0) {
-		aor_like = ast_alloca(strlen(aor_name) + 3);
-		sprintf(aor_like, "%%%s%%", aor_name);
-		var = ast_variable_new("aors LIKE", aor_like, "");
-		if (!var) {
-			return -1;
-		}
-		endpoints = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(),
-			"endpoint", AST_RETRIEVE_FLAG_MULTIPLE, var);
-
-		if (endpoints) {
-		    /*
-		     * Because aors are a string list, we have to use a pattern match but since a simple
-		     * pattern match could return an endpoint that has an aor of "aaabccc" when searching
-		     * for "abc", we still have to iterate over them to find an exact aor match.
-		     */
-		    ao2_callback(endpoints, 0, aor_update_endpoint_state, (char *)aor_name);
-		    ao2_ref(endpoints, -1);
-		}
+	sip_options_aors = ao2_container_alloc_hash(AO2_ALLOC_OPT_LOCK_RWLOCK, 0, AOR_BUCKETS,
+		sip_options_aor_hash, NULL, sip_options_aor_cmp);
+	if (!sip_options_aors) {
+		ast_res_pjsip_cleanup_options_handling();
+		return -1;
 	}
 
-	return 0;
-}
-
-static int contact_update_endpoint_state(void *obj, void *arg, int flags)
-{
-	const struct ast_sip_contact *contact = obj;
-	struct timeval tv = ast_tvnow();
-
-	if (!ast_strlen_zero(contact->endpoint_name) && ((int)(contact->qualify_frequency * 1000)) <= 0 &&
-		contact->expiration_time.tv_sec > tv.tv_sec) {
-
-		if (ast_sip_persistent_endpoint_update_state(contact->endpoint_name, AST_ENDPOINT_ONLINE) == -1) {
-			ast_log(LOG_WARNING, "Unable to find persistent endpoint '%s' for contact '%s/%s'\n",
-				contact->endpoint_name, contact->aor, contact->uri);
-			return -1;
+	if (!sip_options_contact_statuses) {
+		sip_options_contact_statuses = ao2_container_alloc_hash(AO2_ALLOC_OPT_LOCK_MUTEX, 0, CONTACT_BUCKETS,
+			sip_contact_status_hash, NULL, sip_contact_status_cmp);
+		if (!sip_options_contact_statuses) {
+			ast_res_pjsip_cleanup_options_handling();
+		return -1;
 		}
 	}
 
-	return 0;
-}
-
-static void update_all_unqualified_endpoints(void)
-{
-	struct ao2_container *aors;
-	struct ao2_container *contacts;
-	RAII_VAR(struct ast_variable *, var_aor, NULL, ast_variables_destroy);
-	RAII_VAR(struct ast_variable *, var_contact, NULL, ast_variables_destroy);
-	RAII_VAR(char *, time_now, NULL, ast_free);
-	struct timeval tv = ast_tvnow();
-
-	if (!(var_aor = ast_variable_new("contact !=", "", ""))) {
-		return;
-	}
-	if (!(var_aor->next = ast_variable_new("qualify_frequency <=", "0", ""))) {
-		return;
-	}
-
-	if (ast_asprintf(&time_now, "%ld", tv.tv_sec) == -1) {
-		return;
-	}
-	if (!(var_contact = ast_variable_new("expiration_time >", time_now, ""))) {
-		return;
-	}
-	if (!(var_contact->next = ast_variable_new("qualify_frequency <=", "0", ""))) {
-		return;
-	}
-
-	aors = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(),
-		"aor", AST_RETRIEVE_FLAG_MULTIPLE, var_aor);
-	if (aors) {
-		ao2_callback(aors, OBJ_NODATA, on_aor_update_endpoint_state, NULL);
-		ao2_ref(aors, -1);
+	sip_options_endpoint_state_compositors = ao2_container_alloc_hash(AO2_ALLOC_OPT_LOCK_RWLOCK, 0, ENDPOINT_STATE_COMPOSITOR_BUCKETS,
+		sip_endpoint_state_compositor_hash, NULL, sip_endpoint_state_compositor_cmp);
+	if (!sip_options_endpoint_state_compositors) {
+		ast_res_pjsip_cleanup_options_handling();
+		return -1;
 	}
 
-	contacts = ast_sorcery_retrieve_by_fields(ast_sip_get_sorcery(),
-		"contact", AST_RETRIEVE_FLAG_MULTIPLE, var_contact);
-	if (contacts) {
-		ao2_callback(contacts, OBJ_NODATA, contact_update_endpoint_state, NULL);
-		ao2_ref(contacts, -1);
+	ast_taskprocessor_build_name(tps_name, sizeof(tps_name), "pjsip/options/manage");
+	management_serializer = ast_sip_create_serializer_named(tps_name);
+	if (!management_serializer) {
+		ast_res_pjsip_cleanup_options_handling();
+		return -1;
 	}
-}
 
-int ast_res_pjsip_init_options_handling(int reload)
-{
-	static const pj_str_t STR_OPTIONS = { "OPTIONS", 7 };
-
-	if (reload) {
-		qualify_and_schedule_all();
-		return 0;
+	if (ast_sorcery_observer_add(ast_sip_get_sorcery(), "endpoint", &endpoint_observer_callbacks)) {
+		ast_res_pjsip_cleanup_options_handling();
+		return -1;
 	}
 
-	sched_qualifies = ao2_t_container_alloc(QUALIFIED_BUCKETS,
-		sched_qualifies_hash_fn, sched_qualifies_cmp_fn,
-		"Create container for scheduled qualifies");
-	if (!sched_qualifies) {
+	if (ast_sorcery_observer_add(ast_sip_get_sorcery(), "aor", &aor_observer_callbacks)) {
+		ast_res_pjsip_cleanup_options_handling();
 		return -1;
 	}
 
-	if (pjsip_endpt_register_module(ast_sip_get_pjsip_endpoint(), &options_module) != PJ_SUCCESS) {
-		ao2_cleanup(sched_qualifies);
-		sched_qualifies = NULL;
+	if (ast_sorcery_observer_add(ast_sip_get_sorcery(), "contact", &contact_observer_callbacks)) {
+		ast_res_pjsip_cleanup_options_handling();
 		return -1;
 	}
 
-	if (pjsip_endpt_add_capability(ast_sip_get_pjsip_endpoint(), NULL, PJSIP_H_ALLOW,
-		NULL, 1, &STR_OPTIONS) != PJ_SUCCESS) {
-		pjsip_endpt_unregister_module(ast_sip_get_pjsip_endpoint(), &options_module);
-		ao2_cleanup(sched_qualifies);
-		sched_qualifies = NULL;
+	sched = ast_sched_context_create();
+	if (!sched) {
+		ast_res_pjsip_cleanup_options_handling();
 		return -1;
 	}
 
-	if (ast_sorcery_observer_add(ast_sip_get_sorcery(), "aor", &observer_callbacks_options)) {
-		pjsip_endpt_unregister_module(ast_sip_get_pjsip_endpoint(), &options_module);
-		ao2_cleanup(sched_qualifies);
-		sched_qualifies = NULL;
+	if (ast_sched_start_thread(sched)) {
+		ast_res_pjsip_cleanup_options_handling();
 		return -1;
 	}
 
+	sip_options_synchronize(0);
+
 	internal_sip_register_endpoint_formatter(&contact_status_formatter);
 	ast_manager_register2("PJSIPQualify", EVENT_FLAG_SYSTEM | EVENT_FLAG_REPORTING, ami_sip_qualify, NULL, NULL, NULL);
 	ast_cli_register_multiple(cli_options, ARRAY_LEN(cli_options));
 
-	update_all_unqualified_endpoints();
-	qualify_and_schedule_all();
-
 	return 0;
 }
-
-void ast_res_pjsip_cleanup_options_handling(void)
-{
-	ast_cli_unregister_multiple(cli_options, ARRAY_LEN(cli_options));
-	ast_manager_unregister("PJSIPQualify");
-	internal_sip_unregister_endpoint_formatter(&contact_status_formatter);
-
-	ast_sorcery_observer_remove(ast_sip_get_sorcery(), "aor", &observer_callbacks_options);
-	pjsip_endpt_unregister_module(ast_sip_get_pjsip_endpoint(), &options_module);
-	ao2_cleanup(sched_qualifies);
-	sched_qualifies = NULL;
-}
